<template>
  <div class="container">
    <div class="row justify-content-center">
      <div class="col-md-8">

        <h4 class="m-3">Create review</h4>
        <div class="m-3 d-block">
          <textarea v-model="text" class="form-control" placeholder="text review" required></textarea>
        </div>

        <div ref="dropzone" class="p-3 m-3 d-block btn bg-dark text-center text-light">
          Upload Images
        </div>
        <input @click.prevent="storeReview" class="m-3 btn bg-primary" type="submit" value="Add">

        <template v-if="reviews.length">
          <h4 class="m-3">Reviews list</h4>
          <ul class="list-group">
            <li v-for="review in reviews" :key="review.id" class="list-group-item m-2">
              <div class="d-flex justify-content-between align-items-center">
                <div>
                  <strong>{{ review.user.name }}</strong>
                </div>
                <div>
                  <span class="text-muted">{{ review.created_at}}</span>
                </div>
              </div>

              <p>{{ review.text }}</p>
              <div>
                <img v-for="image in review.images" :key="image.id" :src="image.url_thumb" alt="Review Thumbnail" class="img-thumbnail mr-2" style="width: 150px;">
              </div>
            </li>
          </ul>
        </template>

      </div>
    </div>
  </div>
</template>

<style>

.dz-success-mark, .dz-error-mark {
  display: none;
}

</style>

<script>

import {Dropzone} from "dropzone";

export default {
  name: 'Review',

  data() {
    return {
      dropzone: null,
      textError: false,
      reviews: [],
      text: '',
    }
  },

  mounted() {
    this.dropzone = new Dropzone(this.$refs.dropzone, {
      url: '/reviews',
      autoProcessQueue: false,
      addRemoveLinks: true
    })
    this.fetchReviews();
  },

  methods: {
    storeReview() {

      this.textError = false;
      if (!this.text) {
        this.textError = true;
        return;
      }

      const data = new FormData()
      const images = this.dropzone.getAcceptedFiles()

      images.forEach(
          image => {
            data.append('images[]', image)
          }
      )

      data.append('text', this.text)

      axios.post('/reviews', data,
          {
            headers: {
              'Content-Type': 'multipart/form-data'
            }
          }).then(response => {
        this.reviews.push(response.data.data);
        this.dropzone.removeAllFiles()
        this.text = ''
      })
          .catch(error => {
            console.error('Error creating review:', error);
          });
    },

    fetchReviews() {
      axios.get('/reviews')
          .then(response => {
            this.reviews = response.data.data;
          })
          .catch(error => {
            console.error('Error fetching reviews:', error);
          });
    }
  }
}
</script>
